<?php
// AutoDirector user object
class userObject
{
	var $db;
	var $email;
	var $password;
	var $supervisor;
	var $adminsites;
	var $usersites;
	var $lastlogin;
	var $userupdate;
	var $lastupdate;

	// object constructor
	function userObject() {
		$this->email='';
	}


	// set the shared database object
	function selectDB($dbobject='') {
		if ($dbobject!=='') $this->db=$dbobject;
	}


	// get user information from the database
	function fetchUser($email='') {

		$ret=false;

		if ($email!='') {
			if ($this->db->fetch("SELECT email,password,supervisor,adminsites,usersites,lastlogin,userupdate,lastupdate FROM users WHERE email=".SQLescape($email).";")) {

				if ($this->db->rowcount==1) {
					$uinfo=$this->db->rowassoc();
					$this->email=$uinfo['email'];
					$this->password=$uinfo['password'];
					$this->supervisor=$uinfo['supervisor'];
					$this->adminsites=$uinfo['adminsites'];
					$this->usersites=$uinfo['usersites'];
					$this->lastlogin=$uinfo['lastlogin'];
					$this->userupdate=$uinfo['userupdate'];
					$this->lastupdate=$uinfo['lastupdate'];
					$ret=true;
				}
			}
		}

		return $ret;

	}


	// create a new user
	function createUser($email='', $updater='') {
		$ret=false;

		if ($email!='') {

			$pword=$this->newPassword();
			if ($this->db->fetch("INSERT INTO users (email,password,userupdate,lastupdate) VALUES (".SQLescape($email).", ".SQLescape($pword).", ".SQLescape($updater).", '".gmdate('YmdHis')."');")) {
				if ($this->db->rowcount==1) {
					$this->email=$email;
					$this->password=$pword;
					$ret=true;
				}
			}
		}

		return $ret;
	}


	// generate a random password
	function newPassword() {
		$const='bcdfghjklmnpqrstvwxyz';
		$vowel='aeiou';
		$clen=strlen($const)-1;
		$vlen=strlen($vowel)-1;
		return $const{rand(0,$clen)}.$vowel{rand(0,$vlen)}.$const{rand(0,$clen)}.$const{rand(0,$clen)}.$vowel{rand(0,$vlen)}.$const{rand(0,$clen)};
	}


	// check user ID and password. Return true if user is valid.
	function checkLogin($email='', $password='') {
		$ret=false;
		if ($this->db->fetch("SELECT email FROM users WHERE email=".SQLescape($email)." AND password=".SQLescape($password).";")) {
			if ($this->db->rowcount==1) $ret=true;
		}
		return $ret;
	}


	// updates the user's last login time
	function loggedIn() {
		if ($this->email!='') {
			$this->db->fetch("UPDATE users SET lastlogin='".gmdate('YmdHis')."' WHERE email=".SQLescape($this->email)." AND password=".SQLescape($this->password).";");
		}
	}


	// send user a password reminder by email
	function passwordReminder() {
		$ret='The email address entered could not be found. Please contact your administrator.';
		if ($this->email!='') {
			$body="Your account details are:\n\n";
			$body.="    login page: <".scriptPath().">\n";
			$body.="    email: $this->email\n";
			$body.="    password: $this->password\n\n";
			$body.="We recommend that you change your password after logging on.\n";
			$body.="To change your password, select the 'my account' option from the menu.\n";
			$from="supervisor@".$_SERVER['SERVER_NAME'];
			if (@mail($this->email, 'Your account', $body, "From: $from\r\nReply-To: $from\r\n")) $ret="A password reminder has been sent to $this->email.";
			else $ret="The password for $this->email could not be sent by email. Please contact your administrator.";
		}
		return $ret;
	}


	// is user permitted for this site?
	function permissionLevel($site='#NO SITE#') {

		if ($this->supervisor) $ret=3;
		elseif (strpos($this->adminsites, "[$site]")!==false) $ret=2;
		elseif (strpos($this->usersites, "[$site]")!==false) $ret=1;
		else $ret=0;

		return $ret;

	}


	// return array of sites at admin permission level
	function adminSites() {
		$sites=NULL;
		$sitelist=$this->adminsites;
		if ($sitelist!='') {
			$sitelist=substr($sitelist, 1, strlen($sitelist)-2);
			$sites=explode('][', $sitelist);
		}
		return $sites;
	}


	// return array of sites at user permission level
	function userSites() {
		$sites=NULL;
		$sitelist=$this->usersites;
		if ($sitelist!='') {
			$sitelist=substr($sitelist, 1, strlen($sitelist)-2);
			$sites=explode('][', $sitelist);
		}
		return $sites;
	}


	// update user's email address
	function updateEmail($emailnew='', $updater='') {
		$ret=false;
		if ($emailnew!='') {
			if ($this->db->fetch("UPDATE users SET email=".SQLescape($emailnew).", userupdate=".SQLescape($updater).", lastupdate='".gmdate('YmdHis')."' WHERE email=".SQLescape($this->email)." AND password=".SQLescape($this->password).";")) {
				if ($this->db->rowcount==1) {
					$this->email=$emailnew;
					$ret=true;
				}
			}
		}
		return $ret;
	}


	// update user's password
	function updatePassword($passwordnew='', $updater='') {
		$ret=false;
		if ($passwordnew!='') {
			if ($this->db->fetch("UPDATE users SET password=".SQLescape($passwordnew).", userupdate=".SQLescape($updater).", lastupdate='".gmdate('YmdHis')."' WHERE email=".SQLescape($this->email)." AND password=".SQLescape($this->password).";")) {
				if ($this->db->rowcount==1) {
					$this->password=$passwordnew;
					$ret=true;
				}
			}
		}
		return $ret;
	}


	// grant administrator rights to a site
	function grantAdmin($site='') {
		if ($this->email!='' && !$this->supervisor && $site!='') {
			if (strpos($this->adminsites, "[$site]")===false) $this->adminsites.="[$site]";
			if (strpos($this->usersites, "[$site]")!==false) $this->usersites=str_replace("[$site]", '', $this->usersites);
		}
	}


	// grant user rights to a site
	function grantUser($site='') {
		if ($this->email!='' && !$this->supervisor && $site!='') {
			if (strpos($this->usersites, "[$site]")===false) $this->usersites.="[$site]";
			if (strpos($this->adminsites, "[$site]")!==false) $this->adminsites=str_replace("[$site]", '', $this->adminsites);
		}
	}


	// revoke user's right to a site (admin or user)
	function revokeSite($site='') {
		if ($this->email!='' && !$this->supervisor && $site!='') {
			$this->adminsites=str_replace("[$site]", '', $this->adminsites);
			$this->usersites=str_replace("[$site]", '', $this->usersites);
		}
	}


	// update the user rights in the database
	function updateRights($updater='') {

		$ret=false;
		if ($this->email!='') {

			$run=false;
			if ($this->supervisor || $this->adminsites!='' || $this->usersites!='') {

				// change user rights
				$run=$this->db->fetch("UPDATE users SET adminsites=".SQLescape($this->adminsites).", usersites=".SQLescape($this->usersites).", userupdate=".SQLescape($updater).", lastupdate='".gmdate('YmdHis')."' WHERE email=".SQLescape($this->email)." AND password=".SQLescape($this->password).";");

			}
			else {

				// no more rights - delete user
				$run=$this->db->fetch("DELETE FROM users WHERE email=".SQLescape($this->email)." AND password=".SQLescape($this->password).";");
				$this->email='';

			}
			if ($run && $this->db->rowcount==1) $ret=true;
		}
		return $ret;

	}


}
?>