<?php
// AutoDirector main login screen

// set application defaults
$defaults='INCLUDEFOLDER;IMAGEFOLDER;DATAFOLDER;TITLE;';

$inifile='autodirector.ini';
$ini=parse_ini_file($inifile);
foreach ($ini as $key=>$value) {
	define($key, $value);
	$defaults=str_replace($key.';', '', $defaults);
}
unset($ini);

// missing application defaults
if ($defaults!='') {
	print "The following parameters are missing from the $inifile file:\n $defaults";
	exit;
}
unset($defaults);


// ________________________________________________________
// MAIN APPLICATION

// PHP includes
require(INCLUDEFOLDER.'dbhandler.php');
require(INCLUDEFOLDER.'aduser.php');
require(INCLUDEFOLDER.'adfunctions.php');

// set defaults
define('THISURL', $_SERVER['PHP_SELF']);
define('FULLURL', scriptPath());

// find user information
$email=postvar('email');
$password=postvar('password');
$msg='';

if ($email!='') {

	// setup database and user objects
	$db=new dbObject;
	$thisUser=new userObject;
	$thisUser->selectDB($db);

	// is user valid
	if ($thisUser->fetchUser($email)) {

		// handle password reminder
		if ($password=='') {
			$msg=$thisUser->passwordReminder();
		}
		else {
			// is user valid?
			if ($thisUser->checkLogin($email, $password)) {

				// log user on
				writeCookie('aduserid', $email);

				// update log in time
				$thisUser->loggedIn();

				// redirect to correct page
				$sites=array();
				$adminSites=$thisUser->adminSites();
				$userSites=$thisUser->userSites();
				if (is_array($adminSites)) $sites=array_merge($sites, $adminSites);
				if (is_array($userSites)) $sites=array_merge($sites, $userSites);

				if (!$thisUser->supervisor && count($sites)==1) header('Location: '.FULLURL."vehicleadmin.php?siteid=$sites[0]");
				else header('Location: '.FULLURL."siteadmin.php");
				exit();
			}
			else {
				$msg='The user ID and/or password you entered is not authorised to use this system. Please try again.';
			}
		}
	}
	else {
		$msg='The user ID and/or password you entered is not authorised to use this system. Please try again.';
	}

	// disconnect from database
	$db->dbDisconnect();
	unset($db);

	// unload variables
	unset($thisUser);
}


// log user off
writeCookie('aduserid');
writeCookie('adsiteid');

// show login screen
showLogin($email, $msg);


// ________________________________________________________
// login screen
function showLogin($email='', $msg='') {
	global $h1;

	// page header
	$pagetitle='user login';
	require(INCLUDEFOLDER.'adpagehead.php');

	// JavaScript includes
	print '<script type="text/javascript" src="'.INCLUDEFOLDER.'adscript.js"></script>';
	print '<script type="text/javascript" src="'.INCLUDEFOLDER.'adscriptlogin.js"></script>';

	// login form
	print $h1.'<form name="autodirector" action="'.THISURL.'" method="post" onsubmit="return checkLogin()">';
	if ($msg!='') print "<p class=\"error\">$msg</p>";
	else print '<p>Please enter your email address and password to log on.</p>';
	print '<table align="center" border="0" cellpadding="0" cellspacing="6" summary="login form">';
	print '<tr><td><b>email address:</b></td><td><input type="text" name="email" value="'.$email.'" size="30" maxlength="100" /></td></tr>';
	print '<tr><td><b>password:</b></td><td><input type="password" name="password" value="" size="20" maxlength="20" /></td></tr>';
	print '<tr><td colspan="2" align="center"><input type="submit" value="continue" class="button" /></td></tr>';
	print '</table></form>';
	print '<p>Forgotten your password? Leave the password box blank to receive a reminder by email.</p>';
	print '<div style="margin:2em 4em 2em 4em;padding:8px;background-color:#eeffff;border:3px ridge;"><span class="error">IMPORTANT NOTES:</span><br />Please ensure your browser has JavaScript and cookies enabled.<br />To avoid data loss, please do <b>not</b> use your browser\'s back, next, stop or refresh buttons.</div>';
	print '<script type="text/javascript">document.autodirector.email.focus();</script>';

	// page footer
	require(INCLUDEFOLDER.'adpagefoot.php');
}
?>
